Package: org.codehaus.groovy.ast.expr

## [Java] Class DeclarationExpression

- org.codehaus.groovy.ast.expr.DeclarationExpression

- Represents one or more local variables. Typically it is a single local variable declared by name with an expression like "def foo" or with type "String foo". However, the multiple assignment feature allows you to create two or more variables using an expression like: `def (x, y) = [1, 2]`.

  You can access the left hand side of a declaration using the "`Expression getLeftExpression()`" method. In which case you might then use `instanceof` and casting to perform operations specific to a single local variable (`VariableExpression`) or for the multiple assignment case (`TupleExpression`).

  Alternatively, if `isMultipleAssignmentDeclaration()` is `false` you can use the method "`VariableExpression getVariableExpression()`" method. Similarly, if `isMultipleAssignmentDeclaration()` is `true` you can use the method "`TupleExpression getTupleExpression()`" method. Calling either of these expression getters when the "isMultipleAssignment" condition is not appropriate is unsafe and will result in a `ClassCastException`.

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class Expression` | `EMPTY_ARRAY`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DeclarationExpression (VariableExpression left, Token operation, Expression right)` Creates a DeclarationExpression for VariableExpressions like "def x" or "String y = 'foo'".
    `DeclarationExpression (Expression left, Token operation, Expression right)` Creates a DeclarationExpression for Expressions like "def (x, y) = [1, 2]"

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `String` | `getText()`
    `` | `TupleExpression` | `getTupleExpression()` This method returns the left hand side of the declaration cast to the TupleExpression type.
    `` | `VariableExpression` | `getVariableExpression()` This method returns the left hand side of the declaration cast to the VariableExpression type.
    `` | `boolean` | `isMultipleAssignmentDeclaration()` This method tells you if this declaration is a multiple assignment declaration, which has the form "def (x, y) = ..." in Groovy.
    `` | `void` | `setLeftExpression(Expression leftExpression)` This method sets the leftExpression for this BinaryExpression.
    `` | `void` | `setRightExpression(Expression rightExpression)`
    `` | `Expression` | `transformExpression(ExpressionTransformer transformer)`
    `` | `void` | `visit(GroovyCodeVisitor visitor)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class BinaryExpression` | `getLeftExpression, getOperation, getRightExpression, getText, isSafe, newAssignmentExpression, newInitializationExpression, setLeftExpression, setRightExpression, setSafe, toString, transformExpression, visit`
    `class Expression` | `getType, setType, transformExpression, transformExpressions, transformExpressions`
    `class AnnotatedNode` | `addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, getGroovydoc, getInstance, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`
    `class ASTNode` | `copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getMetaDataMap, getText, hashCode, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setMetaDataMap, setSourcePosition, visit`

- - ### Constructor Detail

    - #### public DeclarationExpression(VariableExpression left, Token operation, Expression right)

      Creates a DeclarationExpression for VariableExpressions like "def x" or "String y = 'foo'".

      Parameters:
        `left` - the left hand side of a variable declaration
        `operation` - the operation, typically an assignment operator
        `right` - the right hand side of a declaration

    - #### public DeclarationExpression(Expression left, Token operation, Expression right)

      Creates a DeclarationExpression for Expressions like "def (x, y) = [1, 2]"

      Parameters:
        `left` - the left hand side of a declaration. Must be either a VariableExpression or a TupleExpression with at least one element.
        `operation` - the operation, typically an assignment operator
        `right` - the right hand side of a declaration

  - ### Method Detail

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public String getText()

    - #### public TupleExpression getTupleExpression()

      This method returns the left hand side of the declaration cast to the TupleExpression type. This is an unsafe method to call. In a single assignment statement, the left hand side will be a VariableExpression and a ClassCastException will occur. If you invoke this method then be sure to invoke isMultipleAssignmentDeclaration() first to check that it is safe to do so. If that method returns true then this method is safe to call.

      throws:
        ClassCastException if the left hand side is not a TupleExpression (and is probably a VariableExpression).
      Returns:
        left hand side of multiple assignment declarations

    - #### public VariableExpression getVariableExpression()

      This method returns the left hand side of the declaration cast to the VariableExpression type. This is an unsafe method to call. In a multiple assignment statement, the left hand side will be a TupleExpression and a ClassCastException will occur. If you invoke this method then be sure to invoke isMultipleAssignmentDeclaration() first to check that it is safe to do so. If that method returns true then this method is safe to call.

      throws:
        ClassCastException if the left hand side is not a VariableExpression (and is probably a multiple assignment statement).
      Returns:
        left hand side of normal variable declarations

    - #### public boolean isMultipleAssignmentDeclaration()

      This method tells you if this declaration is a multiple assignment declaration, which has the form "def (x, y) = ..." in Groovy. If this method returns true, then the left hand side is an ArgumentListExpression. Do not call "getVariableExpression()" on this object if this method returns true, instead use "getLeftExpression()".

      Returns:
        true if this declaration is a multiple assignment declaration, which means the left hand side is an ArgumentListExpression.

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public void setLeftExpression(Expression leftExpression)

      This method sets the leftExpression for this BinaryExpression. The parameter must be either a VariableExpression or a TupleExpression with one or more elements.

      Parameters:
        `leftExpression` - either a VariableExpression or a TupleExpression with one or more elements.

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public void setRightExpression(Expression rightExpression)

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public Expression transformExpression(ExpressionTransformer transformer)

    - #### @com.github.javaparser.ast.expr.MarkerAnnotationExprOverride public void visit(GroovyCodeVisitor visitor)